package Sentinel::Test;

use strict;
use vars qw( @ISA %AUTOFIELDS );

use Sentinel::Base;
@ISA = qw( Sentinel::Base );

%AUTOFIELDS = (
	args => undef,
	test => undef,
	message => undef,
	status => undef,
	host => undef
);

sub run_test
{
	my $self = shift;
	my $host = shift;

	$self -> logmsg( "Test: " . $self -> test() );
	$self -> message( "No Message" );

	# Load the test class
	my $module = "Sentinel::Tests::" . $self -> test();
	my $code = eval {
		local $SIG{ __DIE__ } = sub {0};
		eval( "require $module" ) 
	};
	if( $code )
	{
		$self -> logmsg( "Module $module loaded" );

		my $test = $module -> new();
		$test -> host( $host );
		$test -> args( $self -> args() );

		$test -> lib_host( $self -> host() -> lib_host() );
		$test -> lib_port( $self -> host() -> lib_port() );

		# Pass back test status/message
		$self -> status( $test -> execute() );
		$self -> message( $test -> message() );
	}else
	{
		$self -> logmsg( "Could not load: $module" );
		$self -> status( 1 );
		$self -> message( "Could not load: $module" );
	}

	if( $self -> status() != 0 )
	{
		# Stupid me, must sent message here.  The parent doesn't get any of this
		# data
		$self -> logmsg( "Test failed" );
		$self -> host() -> sentinel() ->
			send_notification( $self -> host() -> display_name(),
				"FAIL(" . $self -> test() . ")",
				$self -> message() );
	}

	return( $self -> status() );
}

1;
