package Sentinel::Tests::md5_check;

use Sentinel::Tests::Base;
@ISA = qw( Sentinel::Tests::Base );

use DB_File;

sub execute
{
	my $self = shift;
	my( %hash );
	my $host = $self -> host_addr();
	my $file = $self -> opt( 'file' );
	my $hfkey = "$host,$file";

	my $foo = $self -> probe( undef, $file );

	tie %hash, 'DB_File', 'data/md5_check';

	if( $foo == 200 )
	{
		# Validate MD5 data
		if( $hash{ $hfkey } )
		{
			if( $hash{ $hfkey } ne $self -> probe_message() )
			{
				$self -> message( "ALERT! File '$file' on host $host has changed!" );
				return( 1 );
			}

			$self -> logmsg( "Size/MD5 match" );
			return( 0 );
		}else
		{
			$self -> message( qq{Warning: adding new MD5 data for '$file' on $host.  
YOU SHOULD GET THIS ONLY ONCE PER FILE/HOST,
OTHERWISE YOUR MD5 DATABASE MAY HAVE BEEN DELETED} );

			$hash{ $hfkey } = $self -> probe_message(); # This is a combo size/md5
			return( 1 );
		}
	}

	$self -> message( $self -> probe_message() );
	return( 1 );
}

1;
