package Sentinel::Tests::ping_echo;

use Sentinel::Tests::Base;
@ISA = qw( Sentinel::Tests::Base );

use IO::Socket::INET;

# This will check if a host is alive by connecting to a port using TCP
# It can take an override port, or defaults to the echo port
# If connection refused/connect is returned, then it assumes host is
# alive, if timeout is reached then no host is alive
sub execute
{
	my $self = shift;
	$self -> message( "Ping test executing" );

	my $s;
	
	eval{
		local $SIG{ __DIE__ } = sub { 0 };
		$s = IO::Socket::INET -> new(
			PeerAddr => $self -> host_addr(),
			PeerPort => 'echo',
			Proto => 'tcp' );
	};
	
	if( $s )
	{
		return( 0 );
	}else
	{
		$self -> message( "Error: $!" );
		return( 1 );
	}
}

1;
